package cn.yyxx.eyuangame.core.linking

import android.content.Context
import cn.yyxx.eyuangame.core.internal.IEventObserver
import cn.yyxx.eyuangame.core.linking.channel.LinkingAdjustImpl
import cn.yyxx.eyuangame.core.linking.channel.LinkingFacebookImpl
import cn.yyxx.eyuangame.core.linking.channel.LinkingFirebaseImpl

/**
 * @author #Suyghur.
 * Created on 2021/06/17
 */
class Linking private constructor() {

    private val observers: MutableList<IEventObserver> = mutableListOf()

    fun attach(context: Context) {
        observers.add(LinkingAdjustImpl())
        observers.add(LinkingFirebaseImpl())
        observers.add(LinkingFacebookImpl())
    }


    fun detach() {
        if (!observers.isNullOrEmpty()) {
            observers.clear()
        }
    }


    fun login(context: Context) {
        for (ob in observers) {
            ob.onLogin(context)
        }
    }

    fun register(context: Context) {
        for (ob in observers) {
            ob.onRegister(context)
        }
    }

    fun charge(context: Context) {
        for (ob in observers) {
            ob.onCharge(context)
        }
    }

    fun roleCreate(context: Context) {
        for (ob in observers) {
            ob.onCharge(context)
        }
    }

    fun roleLauncher(context: Context) {
        for (ob in observers) {
            ob.onCharge(context)
        }
    }

    fun event(context: Context) {
        for (ob in observers) {
            ob.onEvent(context)
        }
    }


    companion object {
        val instance: Linking by lazy(mode = LazyThreadSafetyMode.SYNCHRONIZED) {
            Linking()
        }
    }
}